unit hiMultiElementEx;

interface

uses Windows,Kol,Share,hiEditMultiEx,Debug;

var
   started: boolean;
   hMapFile:THandle;
   pBuf:pointer; 
   lpszBuf:LPTSTR;
   BUF_SIZE,map_cnt:integer; //=25609.09.2011
   mydebug,entrybp,exitbp,freezelogres,freezeval:string;
     
type
 TOnCreate = function(_parent:pointer; Control:PControl; ParentClass:TObject):THIEditMultiEx;
 THIMultiElementEx = class(TDebug)
   private
     FChild:THIEditMultiEx;
     FOnCreate:TOnCreate;
     procedure SetCreateProc(Value:TOnCreate);
     function CreateInstance:THIEditMultiEx;
     function TestEvent(F:THIEditMultiEx;G:PListEH):boolean;
  
     

   protected
     FList:PList;
     FControl:PControl;
     function AddInstance:THIEditMultiEx;
     procedure RemoveInstance(pInstance:THIEditMultiEx);
   public
     _prop_Mode:byte;
     _prop_Id:string;
     _prop_EntryBP:string;
     _prop_ExitBP:string;
     _prop_Debug:string;
     _prop_EntryMessage:string;
     _prop_ExitMessage:string;
     
     //_event_onReadDebug:THI_Event;
     
     EvHandle:PListEH;
     Events:array of THI_Event;
     Datas:array of THI_Event;
     
     ParentClass:TObject;

     constructor Create(Control:PControl); overload;
     constructor Create; overload; //temp
     destructor Destroy; override;
     procedure Init;
     procedure doWork(var Data:TData; Index:word);
     procedure getVar(var Data:TData; Index:word);
     procedure Add(var Data:TData; Index:word);
     procedure Select(var Data:TData; Index:word);
     procedure Delete(var Data:TData; Index:word);
     procedure Clear(var Data:TData; Index:word);
     procedure Count(var Data:TData; Index:word);
     procedure HSelect(var Data:TData; Index:word);
     procedure HDelete(var Data:TData; Index:word);
     procedure Handle(var Data:TData; Index:word);
     procedure Index(var Data:TData; Index:word);
     procedure EventIndex(var Data:TData; Index:word);
     procedure EventHandle(var Data:TData; Index:word);
     procedure ReportStart;
     procedure ReportEnd;
     
     
     procedure ReadDebugLog(var _Data:TData; Index:word);          
     procedure SetId(var _Data:TData; Index:word);
      procedure SetEntryBP(var _Data:TData; Index:word);
       procedure SetExitBP(var _Data:TData; Index:word);
        procedure SetDebug(var _Data:TData; Index:word);
         procedure SetEntryMessage(var _Data:TData; Index:word);
           procedure SetExitMessage(var _Data:TData; Index:word); 
            procedure StartStopLog(var _Data:TData; Index:word);
             procedure ActivityLog(var _Data:TData; Index:word);
             procedure ResetCounter(var _Data:TData; Index:word);
              procedure DelLog(var _Data:TData; Index:word);
               procedure SetActivityLabel(var _Data:TData; Index:word);
              
               


     property OnCreate:TOnCreate write SetCreateProc;
 end;
  
  function ReadSharedMemory(n:string):string; 
  procedure WriteSharedMemory(n,s:string);
  procedure DeleteSharedMemory (n:string);
  function InitSharedMemory(mapname:Pchar):string;
  procedure SetSharedMem(lpszBuf:LPTSTR); stdcall;
  function GetSharedMem():Pchar; stdcall;

implementation

var
cont_id:string;
logres,error,name,entry_t,exit_t,lasterror:string;
isEntryBP,isExitBP,isDebug:integer;


function THIMultiElementEx.AddInstance:THIEditMultiEx;
begin
   FChild := CreateInstance;
   FList.Add(FChild); Result := FChild;
end;

procedure THIMultiElementEx.RemoveInstance(pInstance:THIEditMultiEx);
begin
   if FChild = pInstance then FChild := nil;
   pInstance.MainClass.Destroy;
   FList.Remove(pInstance);
end;

constructor THIMultiElementEx.Create(Control:PControl);
begin
   Create;
   FControl := Control;
end;

constructor THIMultiElementEx.Create;
begin
   inherited Create;
   FList := NewList;   
end;

destructor THIMultiElementEx.Destroy;
begin
  Clear(_data_Empty,$FFFF); //no delete-events
  FList.Free;
  inherited;
  
   if (_prop_Id <> 'debug') AND (_prop_Id <> 'debug_end') AND (mydebug <> '') then _prop_Debug:= mydebug;
   if (_prop_Id = 'debug') OR (_prop_Id = 'debug_end') then mydebug:= _prop_Debug;  
   //ShowMessage(_prop_Id+' exit '+_prop_Debug); 
   if (_prop_Debug='1') AND (_prop_Id <>'') then ReportEnd;  
end;

procedure THIMultiElementEx.Init;
begin
end;


procedure THIMultiElementEx.Add;
begin
   FChild := CreateInstance;
   FList.Add(FChild);
   _hi_OnEvent(FChild.Works[Index],Data);
end;

procedure THIMultiElementEx.Select;
var Ind:integer;
begin
   ind := ToInteger(Data);
   FChild := nil;
   if(ind < 0)or(ind >= FList.Count)then exit;
   FChild := FList.Items[ind];
   _hi_OnEvent(FChild.Works[Index],Data);
end;

function THIMultiElementEx.TestEvent;
begin
  Result := true;
   while assigned(G) do begin
     if F=G.Hnd then begin
       _debug('Self destruction is not allowed !!!');
       exit;
      end;
     G := G.Prv;
    end;
  Result := false;
end;

procedure THIMultiElementEx.Delete;
var Ind:integer;
    F:THIEditMultiEx;
begin
   ind := ToInteger(Data);
   if(ind < 0)or(ind >= FList.Count)then exit;
   F := FList.Items[ind];
   if TestEvent(F,EvHandle) then exit;
   if Index < length(F.Works) then 
     _hi_OnEvent(F.Works[Index],Data);
   if FChild = F then FChild := nil;
   F.MainClass.Destroy;
   FList.delete(ind);
end;

procedure THIMultiElementEx.Clear;
var i:integer; 
begin 
   for i := FList.count-1 downto 0 do begin
     dtInteger(Data,i);
     Delete(Data,Index); //more testng + events before destruction
   end
end;

procedure THIMultiElementEx.Handle(var Data:TData; Index:word);
begin
   dtInteger(Data,integer(FChild));
end;

procedure THIMultiElementEx.EventHandle(var Data:TData; Index:word);
var i:integer;
begin
   i := 0;
   if assigned(EvHandle) then i := integer(EvHandle.Hnd);
   dtInteger(Data,i);
end;

procedure THIMultiElementEx.HSelect(var Data:TData; Index:word);
begin
   FChild := THIEditMultiEx(ToInteger(Data));
   if FList.IndexOf(FChild) = -1 then FChild := nil
   else _hi_OnEvent(FChild.Works[Index],Data);
end;

procedure THIMultiElementEx.HDelete(var Data:TData; Index:word);
var F:THIEditMultiEx;
begin
   F := THIEditMultiEx(ToInteger(Data));
   if (FList.IndexOf(f)=-1)or TestEvent(F,EvHandle) then exit;
   _hi_OnEvent(F.Works[Index],Data);
   if FChild = F then FChild := nil;
   F.MainClass.Destroy;
   FList.Remove(F);
end;

procedure THIMultiElementEx.Index(var Data:TData; Index:word);
begin
  dtInteger(Data,FList.IndexOf(FChild));
end;

procedure THIMultiElementEx.EventIndex(var Data:TData; Index:word);
var i:integer;
begin
  i := -1;
  if assigned(EvHandle) then i := FList.IndexOf(EvHandle.Hnd);
  dtInteger(Data,i);
end;

procedure THIMultiElementEx.doWork;
var F:THIEditMultiEx;
begin
    if FChild = nil then
     begin
      F := CreateInstance;
      _hi_OnEvent(F.Works[Index],Data);
      F.MainClass.Destroy;
     end
    else _hi_OnEvent(FChild.Works[Index],Data);
    
if (_prop_Id <> 'debug') AND (_prop_Id <> 'debug_start') AND (_prop_Id <> 'debug_end')  AND (_prop_Id <> '') AND (mydebug <> '') then  WriteSharedMemory(_prop_Id+'_freeze',freezeval);//added by Aziz on 21.9.2013 to locate frozen containers
    //ShowMessage('ww');
end;

procedure THIMultiElementEx.Count;
begin
   dtInteger(Data,FList.Count);
end;

procedure THIMultiElementEx.getVar;
var F:THIEditMultiEx;
begin
    if FChild = nil then
     begin
      F := CreateInstance;
      _ReadData(Data,F.Vars[Index]);
      F.MainClass.Destroy;
     end
    else  _ReadData(Data,FChild.Vars[Index]);
end;

procedure THIMultiElementEx.SetCreateProc;
begin
   FOnCreate := Value;
   if _prop_Mode<>0 then exit;
   FChild := CreateInstance;
   FList.Add(FChild);
end;


function THIMultiElementEx.CreateInstance;
var PrevNeedInit:boolean;
begin
   PrevNeedInit := NeedInit;
   NeedInit := false;
   Result := FOnCreate(self, FControl, ParentClass);
//   Result.Parent := Self;
   if PrevNeedInit then InitDo;
   if (_prop_Id <> 'debug') AND (_prop_Id <> 'debug_start') AND (mydebug <> '') then _prop_Debug:= mydebug; 
   if (_prop_Id = 'debug') OR (_prop_Id = 'debug_start') then begin 
    mydebug:= _prop_Debug;
    if (_prop_Debug ='1') AND (_prop_Id <>'')  then begin
    WriteSharedMemory('entry_cnt','');
    WriteSharedMemory('exit_cnt',''); end;
    end;
   //ShowMessage(_prop_Id+' - '+_prop_Debug);
   if (_prop_Debug ='1') AND (_prop_Id <>'') then ReportStart;
end;   


//////////// Aziz debug code  14.9.2013

procedure THIMultiElementEx.ReportStart;
var
cnt:integer;
begin
cont_id:=_prop_Id;
cnt:=Str2Int(ReadSharedMemory('entry_cnt'))+1;

if (_prop_Id <> 'debug') AND (_prop_Id <> 'debug_start') AND (entrybp <> '') then _prop_EntryBP:= entrybp;
if (_prop_Id = 'debug') OR (_prop_Id = 'debug_start') then entrybp:= _prop_EntryBP;
//ShowMessage(cont_id+' entry-p '+_prop_EntryBP);
 
if _prop_EntryMessage ='' then begin
WriteSharedMemory(cont_id,Int2Str(cnt)+' '+cont_id+'_Started'); 
WriteSharedMemory('last',Int2Str(cnt)+' '+cont_id+'_Started');
WriteSharedMemory('entry_cnt',Int2Str(cnt));
if _prop_EntryBP ='1' then ShowMessage(Int2Str(cnt)+' '+'Entry point of container: '+cont_id);
end
else begin
 WriteSharedMemory(cont_id,Int2Str(cnt)+' '+_prop_EntryMessage); 
WriteSharedMemory('last',Int2Str(cnt)+' '+_prop_EntryMessage);
WriteSharedMemory('entry_cnt',Int2Str(cnt));
if _prop_EntryBP ='1' then ShowMessage(_prop_EntryMessage);
end;
//ShowMessage(cont_id);  //Int2Str(isEntryBP) 
end;


procedure THIMultiElementEx.ReportEnd;
var
cnt:integer;
begin
cont_id:=_prop_Id;
cnt:=Str2Int(ReadSharedMemory('exit_cnt'))+1;

if (_prop_Id <> 'debug') AND (_prop_Id <> 'debug_end') AND (exitbp <> '') then _prop_ExitBP:= exitbp;
if (_prop_Id = 'debug') OR (_prop_Id = 'debug_end') then exitbp:= _prop_ExitBP;
//ShowMessage(cont_id+' exit-p '+_prop_ExitBP);

if _prop_ExitMessage ='' then begin
WriteSharedMemory(cont_id,Int2Str(cnt)+' '+cont_id+'_Terminated'); 
WriteSharedMemory('last',Int2Str(cnt)+' '+cont_id+'_Terminated');
WriteSharedMemory('exit_cnt',Int2Str(cnt));
if _prop_ExitBP ='1' then ShowMessage('Exit point of container: '+cont_id);
end
else begin
WriteSharedMemory(cont_id,Int2Str(cnt)+' '+_prop_ExitMessage); 
WriteSharedMemory('last',Int2Str(cnt)+' '+_prop_ExitMessage);
WriteSharedMemory('exit_cnt',Int2Str(cnt));
if _prop_ExitBP ='1' then ShowMessage(_prop_ExitMessage);
end;
//ShowMessage(cont_id);
end;



procedure THIMultiElementEx.DelLog;
var n:string;
begin
n:=ReadString(_Data,FChild.Works[Index],'');
if n <>'' then DeleteSharedMemory (n);
end;

procedure THIMultiElementEx.ResetCounter;
begin
WriteSharedMemory('entry_cnt','');
WriteSharedMemory('exit_cnt',''); 
end;

procedure THIMultiElementEx.SetId;
begin
cont_id:=ReadString(_Data,FChild.Works[Index],'');
//ShowMessage(cont_id);
end;

procedure THIMultiElementEx.SetEntryBP;
begin
entrybp:= ReadString(_Data,FChild.Works[Index],'');
end;

procedure THIMultiElementEx.SetExitBP;
begin
exitbp:= ReadString(_Data,FChild.Works[Index],'');
end;

procedure THIMultiElementEx.SetDebug;
begin 
mydebug:=ReadString(_Data,FChild.Works[Index],'');
end;

procedure THIMultiElementEx.SetEntryMessage;
begin
entry_t:=ReadString(_Data,FChild.Works[Index],'');
end;

procedure THIMultiElementEx.SetExitMessage;
begin
exit_t:=ReadString(_Data,FChild.Works[Index],'');
end;

procedure THIMultiElementEx.ReadDebugLog;
var
ms,s:string;
begin
ms:=ReadString(_Data,FChild.Works[Index],'');
logres:=ReadSharedMemory(ms);
s:=ReadSharedMemory('freeze_val');
freezelogres:='nodata';
if s <> '' then begin 
ms:=ReadSharedMemory(ms+'_freeze');
if ms <> s then freezelogres:='idle/frozen'
else freezelogres:='active'; end;
//ShowMessage(ms);
  // _hi_OnEvent(FChild.Works[Index],Data);
end;

procedure THIMultiElementEx.StartStopLog;
begin
dtString(_data, logres);  
end;


procedure THIMultiElementEx.SetActivityLabel;
var
ms:string;
begin
ms:=ReadString(_Data,FChild.Works[Index],''); 
freezeval:= ms; 
WriteSharedMemory('freeze_val',ms);
end;


procedure THIMultiElementEx.ActivityLog;   
begin
dtString(_data, freezelogres);  
end;

procedure DeleteSharedMemory (n:string); 
begin 
if (error <> '') AND (error = lasterror) then exit;
InitSharedMemory(Pchar(n));
  if (hMapFile <> 0) then
  begin
   SetSharedMem(Pchar(''));
    if Assigned(pBuf) then  UnmapViewOfFile(pBuf);   // if(pBuf<>nil)  then  UnmapViewOfFile(pBuf); 
   CloseHandle(hMapFile);     
  end;
if error <> '' then begin 
ShowMessage(error);
lasterror:=error;
exit;
end;
end;

procedure WriteSharedMemory(n,s:string);  
begin
if  (error <> '') AND (error = lasterror) then exit;
InitSharedMemory(Pchar(n));
SetSharedMem(Pchar(s)); 
if error <> '' then begin 
ShowMessage(error);
lasterror:=error;
exit;
end; 
end;

function ReadSharedMemory(n:string):string;
var s:string;  
begin
if  (error <> '') AND (error = lasterror) then exit;
InitSharedMemory(Pchar(n));
s:=GetSharedMem(); 
if error <> '' then begin 
ShowMessage(error);
lasterror:=error;
exit;
end; 


Result:= s; 
end;




function InitSharedMemory(mapname:Pchar):string;

begin

if Assigned(pBuf) then  UnmapViewOfFile(pBuf); 
hMapFile:= 0;
pBuf:=nil;

error:='';
BUF_SIZE := 256; 

  //ShowMessage(Int2Str(lStrLen(nil)));
  //GetLastError;
  //ShowMessage(SysErrorMessage(GetLastError));
  
 	   hMapFile := OpenFileMapping(
                   FILE_MAP_ALL_ACCESS,   // read/write access
                   FALSE,                 // do not inherit the name
                   mapname);               
   		if(hMapFile=0) then
          begin
			//ShowMessage(mapname+': Already Exists!');
			hMapFile := CreateFileMappingA(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,BUF_SIZE,mapname);
		
	      end;
		if(hMapFile=0) then
          begin
		//	ShowMessage('CreateFileMapping failed!');
			error:= SysErrorMessage(GetLastError)+' Error:'+Int2Str(GetLastError)+' CreateFileMapping failed!';
			    	 
			exit;
	      end;		
   		pBuf := MapViewOfFile(hMapFile, FILE_MAP_ALL_ACCESS, 0, 0, BUF_SIZE);
   		//inc(map_cnt); //max = 31736
		if(pBuf=nil)  then
          begin
		//	ShowMessage('Map View failed!');
			  error:= SysErrorMessage(GetLastError)+' Error:'+Int2Str(GetLastError)+' MapViewOfFile failed! ';//+Int2Str(map_cnt)
			 
			exit;
	      end; 
   
 result :=  error;        
 end;


procedure SetSharedMem(lpszBuf:LPTSTR); stdcall;
var
    lpszTmp : LPTSTR;
    i:integer;
begin                                     
 lpszTmp := LPTSTR( pBuf);
  i:=0;
 
while (lpszBuf[i]<>chr(0)) do
    begin
     lpszTmp[i] := lpszBuf[i];
     inc(i);
   end;
  lpszTmp[i] := chr(0);   
   //ShowMessage(lpszBuf);
end;



function GetSharedMem():Pchar;
var
   lpszTmp:LPTSTR;
   
begin
  lpszTmp := LPTSTR( pBuf);

  Result:= lpszTmp;
end;                                                                                                                                                                                                 


//////////// Aziz debug code  14.9.2013 news108@rambler.ru

end.
